<?php
/**
 * browse.php -- Browse page
 * 
 * Copyright (c) 1999-2003 The Owl Project Team
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 * 
 * $Id: browse.php,v 1.11 2003/11/12 14:25:08 b0zz Exp $
 */

//require_once("./config/owl.php");
require_once(_SYSCOMMONROOT . "/lib/disp.lib.php");
require_once(_SYSCOMMONROOT . "/lib/owl.lib.php");
require_once(_SYSCOMMONROOT . "/lib/readhd.php");
require_once(_SYSCOMMONROOT . "/lib/security.lib.php");
include_once(_SYSCOMMONROOT . "/lib/header.inc");
include_once(_SYSCOMMONROOT . "/lib/userheader.inc");

if (!isset($parent) || $parent == "") 
{
   $parent = "1";
}
if (!isset($nextfiles)) 
{
   $nextfiles = 0;
}
if (!isset($nextfolders)) 
{
   $nextfolders = 0;
}

if (!isset($bDisplayFiles))
{
 $bDisplayFiles = false;
}

if (!isset($expand)) 
{
   $expand = $default->expand;
}
if (!isset($order)) 
{
   $order = "name";
}
if (!isset($sortname)) 
{
   $sortname = "ASC";
}
if (!isset($sortver)) 
{
   $sortver = "ASC, minor_revision ASC";
}
if (!isset($sortcheckedout)) 
{
   $sortcheckedout = "ASC";
}
if (!isset($sortfilename)) 
{
   $sortfilename = "DESC";
}
if (!isset($sortsize)) 
{
   $sortsize = "DESC";
}
if (!isset($sortposted)) 
{
   $sortposted = "DESC";
}
if (!isset($sortmod)) 
{
   $sortmod = "DESC";
}
if (!isset($sort)) 
{
   $sort = "asc";
}
// Display the Footer Tools (Seach, Newsadmin and Admin)
$bDisplayFooterTools = true;

switch ($order)
{
   case "name":
      $sortorder = 'sortname';
      $sort = $sortname;
      break;
   case "major_minor_revision":
      $sortorder = 'sortver';
      $sort = $sortver;
      break;
   case "filename" :
      $sortorder = 'sortfilename';
      $sort = $sortfilename;
      break;
   case "size" :
      $sortorder = 'sortsize';
      $sort = $sortsize;
      break;
   case "creatorid" :
      $sortorder = 'sortposted';
      $sort = $sortposted;
      break;
   case "smodified" :
      $sortorder = 'sortmod';
      $sort = $sortmod;
      break;
   case "checked_out":
      $sortorder = 'sortcheckedout';
      $sort = $sortcheckedout;
      break;
   default:
      $sort = "ASC";
      break;
}
 
// Next and Previous Page Handlers

if ($next == 1) 
{
      $iCurrentPage++;
      $nextfiles = $nextfiles + $default->records_per_page;
      $nextfolders = $nextfolders + $default->records_per_page;
}
if ($prev == 1)
{
      $iCurrentPage--;
      $nextfiles = $nextfiles - $default->records_per_page;
      if ($nextfiles < 0)
      {
         $nextfiles = 0;
      }
      $nextfolders = $nextfolders - $default->records_per_page;
      if ($nextfolders < 0)
      {
         $nextfolders = 0;
      }
}


if (check_auth($parent, "folder_view", $userid) != "1")
{
   printError($owl_lang->err_nofolderaccess);
   exit;
} 

// Tiian changes 2003-07-31
$sql_bro = new Owl_DB;
$sql_bro->query("SELECT id FROM $default->owl_folders_table WHERE id = '$parent' AND name = 'backup';");
if ($sql_bro->num_rows() > 0)
    $is_backup_folder = true; 
else
    $is_backup_folder = false;

$getlastlogin = new Owl_DB;
$getlastlogin->query("SELECT lastlogin FROM $default->owl_users_table where id = '" . $userid . "'");
$getlastlogin->next_record();
$lastlogin = $getlastlogin->f("lastlogin");

// **************************************
// Get File statistics for the status bar
// and for controling Pages
// **************************************
fGetStatusBarCount();

$iFileCount = $iFolderCount + $iFileCount;
   
$whereclause = "";
$DBFolderCount = 0;

$sql = new Owl_DB;
if ($default->hide_backup == 1 && ($usergroupid != "0" || $usergroupid != $default->file_admin_group))
{
   $sql->query("SELECT * from $default->owl_folders_table where parent = '$parent' AND name = 'backup'");
   if ($sql->num_rows() > 0)
   {
      $DBFolderCount++; //count number of filez in db 2 use with array
      $DBFolders[$DBFolderCount] = 'backup'; //create list if files in
   } 

   $whereclause = " AND name <> 'backup'";
} 

if (isset($page))
{
      $iCurrentPage = $page;
      $nextfolders = ($default->records_per_page * $page);
}

if ($default->records_per_page > 0)
{
   $sLimit = "LIMIT $nextfolders,$default->records_per_page";
   $sql->query("SELECT * from $default->owl_folders_table where parent = '$parent' $whereclause order by name $sLimit");
   $iNumberFoldersDisplayed = $sql->num_rows();
}


// *********************************
// Display the Header Tool Bar BEGIN
// *********************************


print("<TABLE WIDTH=$default->table_expand_width BGCOLOR='$default->main_header_bgcolor' style='border:4px double $default->main_header_bgcolor' CELLSPACING=0 CELLPADDING=0 BORDER=$default->table_border HEIGHT=40>\n");

?>
<TR><TD ALIGN=LEFT> 
<?php
fPrintPrefs();
?> 
<FONT SIZE=-1>
<?php
if (!$sess == "0")
{
   fPrintButton("index.php?login=logout&sess=$sess", "btn_logout");
} 
else
{
   fPrintButton("index.php?login=1", "btn_login");
} 

?>
    </FONT></TD>
    <TD ALIGN=RIGHT nowrap> <?php
if ((check_auth($parent, "folder_modify", $userid) == 1) && !$is_backup_folder)
{
   if ($sess != "0" || ($sess == "0" && $default->anon_ro == 0))
   {
      // Add Folder Button
      fPrintButton("modify.php?sess=$sess&action=folder_create&parent=$parent&expand=$expand&order=$order&sortname=$sort", "btn_add_folder");
      // Add URL Button
      fPrintButton("modify.php?sess=$sess&action=file_upload&type=url&parent=$parent&expand=$expand&order=$order&sortname=$sort", "btn_add_url");
      // Add Note Button
      fPrintButton("modify.php?sess=$sess&action=file_upload&type=note&parent=$parent&expand=$expand&order=$order&sortname=$sort", "btn_add_note");
      // Add Document Button
      fPrintButton("modify.php?sess=$sess&action=file_upload&parent=$parent&expand=$expand&order=$order&sortname=$sort", "btn_add_file");
   } 
} 
if ($expand == 1)
{
   fPrintButton("browse.php?sess=$sess&parent=$parent&expand=0&order=$order", "btn_collapse_view");
} 
else
{
   fPrintButton("browse.php?sess=$sess&parent=$parent&expand=1&order=$order", "btn_expand_view");
} 

print("</TD></TR></TABLE>\n");
// *******************************
// Display the Header Tool Bar END
// *******************************

print("<FORM name='FileList' enctype='multipart/form-data' ACTION='dbmodify.php' METHOD=POST>");

if ($default->status_bar_location == 0 || $default->status_bar_location == 2)
{
         fPrintStatusBar($nextfolders, ($nextfiles - $iNumberFoldersDisplayed), $bDisplayFiles, $iFileCount, $iCurrentPage);
} 

print("<CENTER>\n");
if ($expand == 1)
{
   print("\t\t<TABLE WIDTH=$default->table_expand_width BORDER=$default->table_border>\n");
} 
else
{
   print("\t\t<TABLE WIDTH=$default->table_collapse_width BORDER=$default->table_border>\n");
} 

print("\t\t\t<TR><TD></TD></TR>\n");
print("\t\t\t<TR><TD align=left>");

$iNewParent = owlfolderparent($parent);
if ($iNewParent != 0)
{
   print("<A HREF='browse.php?sess=$sess&parent=$iNewParent&expand=$expand&order=$order&$sortorder=$sort' TITLE='$owl_lang->title_return_folder $name'><img border='0' src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_nav/folder_up.gif' width ='16' height='16'></A>");
} 
else
{
   print("<img border='0' src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_nav/folder_up.gif' width ='16' height='16'>");
} 
print gen_navbar($parent);
print("</TD></TR></TABLE>\n");

if ($expand == 1)
{
   print("\t\t<HR WIDTH=$default->table_expand_width>\n");
} 
else
{
   print("\t\t<HR WIDTH=$default->table_collapse_width>\n");
} 

if ($expand == 1)
{
   print("\t\t\t<TABLE WIDTH=$default->table_expand_width style='border:4px double $default->main_header_bgcolor' BORDER=$default->table_border>\n<TR BGCOLOR='$default->table_header_bg'>\n");
   show_link("name", "sortname", $sortname, $order, $sess, $expand, $parent, $owl_lang->title);
   print("<TD align=left>&nbsp;</TD>\n"); 
   if ($default->owl_version_control == 1)
   {
      show_link("major_minor_revision", "sortver", $sortver, $order, $sess, $expand, $parent, $owl_lang->ver);
   } 
   show_link("filename", "sortfilename", $sortfilename, $order, $sess, $expand, $parent, $owl_lang->file);
   show_link("size", "sortsize", $sortsize, $order, $sess, $expand, $parent, $owl_lang->size);
   show_link("creatorid", "sortposted", $sortposted, $order, $sess, $expand, $parent, $owl_lang->postedby);
   show_link("smodified", "sortmod", $sortmod, $order, $sess, $expand, $parent, $owl_lang->modified);
   print("<TD align=left>$owl_lang->actions</TD>\n"); 
   if ($default->owl_version_control == 1)
   {
      show_link("checked_out", "sortcheckedout", $sortcheckedout, $order, $sess, $expand, $parent, $owl_lang->held);
   } 
} 
else
{
   print("\t\t\t<TABLE WIDTH=$default->table_collapse_width style='border:4px double $default->main_header_bgcolor' BORDER=$default->table_border><TR BGCOLOR='$default->table_header_bg'>\n");
   show_link("name", "sortname", $sortname, $order, $sess, $expand, $parent, $owl_lang->title);
   print("<TD align=left>&nbsp;</TD>\n"); 
   if ($default->owl_version_control == 1)
   {
      show_link("major_minor_revision", "sortver", $sortver, $order, $sess, $expand, $parent, $owl_lang->ver);
   } 
   show_link("filename", "sortfilename", $sortfilename, $order, $sess, $expand, $parent, $owl_lang->file);
   show_link("size", "sortsize", $sortsize, $order, $sess, $expand, $parent, $owl_lang->size); 
   if ($default->owl_version_control == 1)
   {
      show_link("checked_out", "sortcheckedout", $sortcheckedout, $order, $sess, $expand, $parent, $owl_lang->held);
   } 
} 
// Looping out Folders
$CountLines = 0;
$sLimit = '';
if ($default->records_per_page > 0)
{
   $sLimit = "LIMIT $nextfolders,$default->records_per_page";

   if ($default->owl_LookAtHD != "false")
   {
      $sql->query("SELECT * from $default->owl_folders_table where parent = '$parent' $whereclause");
      while ($sql->next_record())
      {
         $DBFolderCount++; //count number of filez in db 2 use with array
         $DBFolders[$DBFolderCount] = $sql->f("name"); //create list if files in
      }
   }
}
if ($order == "creatorid")
{
      $sql->query("SELECT * from $default->owl_folders_table where parent = '$parent' $whereclause order by $order $sLimit");
} 
else
{
      $sql->query("SELECT * from $default->owl_folders_table where parent = '$parent' $whereclause order by name $sLimit");
} 

// **********************
// BEGIN Print Folders
// **********************

if ($default->records_per_page > 0)
{
   if ($iNumberFoldersDisplayed < $default->records_per_page)
   {
      $bDisplayFiles = true; 
      if (isset($page))
      {
         $iNumberOfPages = (int) (($iFolderCount / $default->records_per_page));
         $iPageLeft = $page - $iNumberOfPages;

         $iCorrection = 0;
         if($iFolderCount <> 0)
         {
           $iCorrection = $iFolderCount % $default->records_per_page;
         }

         $nextfiles = ($default->records_per_page * $iPageLeft) - $iNumberFoldersDisplayed - $iCorrection;
         if ($nextfiles < 0)
         {
            $nextfiles = 0;
         }
      }
   }
   else
   {
      $bDisplayFiles = false;
   }
}

while ($sql->next_record())
{
   if ($default->restrict_view == 1)
   {
      if (!check_auth($sql->f("id"), "folder_view", $userid))
      {
         if ($default->records_per_page == 0) 
         {
            $DBFolderCount++; //count number of filez in db 2 use with array
            $DBFolders[$DBFolderCount] = $sql->f("name"); //create list if files in
         }
         continue;
      } 
   } 
   // *******************************************
   // Find out how many items (Folders and Files)
   // *******************************************
   $GetItems = new Owl_DB;

   $iItemCount = 0;
   $iParent = $sql->f("parent");
   $GetItems->query("SELECT id from $default->owl_folders_table where parent = '" . $sql->f("id") . "'");

   if ($default->restrict_view == 1)
   {
      while ($GetItems->next_record())
      {
         $bFileDownload = check_auth($GetItems->f("id"), "folder_view", $userid);
         if ($bFileDownload)
         {
            $iItemCount++;
         }
     }
   }
   else
   {
      $iItemCount = $GetItems->num_rows();
   }

   $GetItems->query("SELECT id from $default->owl_files_table where parent = '" . $sql->f("id") . "'");
   if ($default->restrict_view == 1)
   {
      while ($GetItems->next_record())
      {
         $bFileDownload = check_auth($GetItems->f("id"), "file_download", $userid);
         if ($bFileDownload)
         {
            $iItemCount++;
         }
     }
   }
   else
   {
      $iItemCount = $iItemCount + $GetItems->num_rows();
   }

   $CountLines++;
   $PrintLines = $CountLines % 2;
   if ($PrintLines == 0)
      print("\t\t\t\t<TR BGCOLOR='$default->table_cell_bg_alt'>\n");
   else
      print("\t\t\t\t<TR BGCOLOR='$default->table_cell_bg'>\n");

   print("<TD ALIGN=LEFT><A CLASS='Text' HREF='browse.php?sess=$sess&parent=" . $sql->f("id") . "&expand=$expand&order=$order&$sortorder=$sort' TITLE='$owl_lang->title_browse_folder'><IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/icon_filetype/folder_closed.gif' BORDER=0>" . $sql->f("name") . "</A>");

   if ($iItemCount > 0)
   {
      print("<FONT COLOR=blue>&nbsp;($iItemCount)</FONT>");
   } 

   if ($sql->f("description"))
      print("<BR><IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/transparent.gif' BORDER=0><font size=2>" . str_replace("\n", "<BR><IMG SRC=$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/transparent.gif BORDER=0>", $sql->f("description")) . "</font>");

   print("</TD>\n");

   if ($default->records_per_page == 0)
   {
      $DBFolderCount++; //count number of filez in db 2 use with array
      $DBFolders[$DBFolderCount] = $sql->f("name"); //create list if files in
   }

   
   if ($expand == 1)
   {
      if ($default->owl_version_control == 1)
      {
         print("\t\t\t\t<TD>&nbsp;</TD>\n<TD>&nbsp;</TD>\n<TD>&nbsp;</TD>\n<TD>&nbsp;</TD>\n<TD>&nbsp;</TD>\n<TD>&nbsp;</TD>\n");
      } 
      else
      {
         print("\t\t\t\t<TD>&nbsp;</TD>\n<TD>&nbsp;</TD>\n<TD>&nbsp;</TD>\n<TD>&nbsp;</TD>\n<TD>&nbsp;</TD>\n");
      } 
      print("<TD ALIGN=LEFT nowrap>&nbsp;&nbsp;");

      if ($default->owl_version_control == 1)
      {
         print("<IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/16x16.gif' BORDER=0><img src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/x_clear.gif' height=1 width=4>");
      } 
      if (check_auth($sql->f("id"), "folder_delete", $userid) == 1)
      {
         print("<img src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/x_clear.gif' height=1 width=2><A HREF='dbmodify.php?sess=$sess&action=folder_delete&id=" . $sql->f("id") . "&parent=$parent&expand=$expand&order=$order&sortname=$sort'\tonClick='return confirm(\"$owl_lang->reallydelete " . htmlspecialchars($sql->f("name"), ENT_QUOTES) . "?\");'><IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/icon_action/trash.gif' ALT='$owl_lang->alt_del_folder' TITLE='$owl_lang->alt_del_folder'\tBORDER=0 ></A><img src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/x_clear.gif' height=1 width=4>");
      }
      if (check_auth($sql->f("id"), "folder_property", $userid) == 1)
      {
         print("<A HREF='modify.php?sess=$sess&action=folder_modify&id=" . $sql->f("id") . "&parent=$parent&expand=$expand&order=$order&sortname=$sort'><IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/icon_action/edit.gif' BORDER=0 ALT='$owl_lang->alt_mod_folder' TITLE='$owl_lang->alt_mod_folder'></A><img src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/x_clear.gif' height=1 width=4>");
      }
      if (check_auth($sql->f("id"), "folder_modify", $userid) == 1)
      {
         print("<A HREF='move.php?sess=$sess&id=" . $sql->f("id") . "&parent=$parent&expand=$expand&action=folder&order=$order&sortname=$sort'><IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/icon_action/move.gif' BORDER=0 ALT='$owl_lang->alt_move_folder' TITLE='$owl_lang->alt_move_folder'></A><img src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/x_clear.gif' height=1 width=4>");
         print("<IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/16x16.gif' BORDER=0><img src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/x_clear.gif' height=1 width=4>");
         print("<IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/16x16.gif' BORDER=0><img src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/x_clear.gif' height=1 width=4>");
         print("<IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/16x16.gif' BORDER=0><img src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/x_clear.gif' height=1 width=3>");
         print("<IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/16x16.gif' BORDER=0><img src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/x_clear.gif' height=1 width=4>");
      } 
      if (check_auth($sql->f("id"), "folder_view", $userid) == 1)
      {
         $folder_id = $sql->f("id");
         $checksql = new Owl_DB;
         $checksql->query("select * from $default->owl_monitored_folder_table where fid = '$folder_id' and userid = '$userid'");
         $checknumrows = $checksql->num_rows($checksql);

         $checksql->query("SELECT * from $default->owl_users_table where id = '$userid'");
         $checksql->next_record();
         if ($default->owl_version_control == 1)
         {
            print("<IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/16x16.gif' BORDER=0><img src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/x_clear.gif' height=1 width=4>");
         } 

         if (trim($checksql->f("email")) != "")
         {
            if ($checknumrows == 0)
            {
               print("<A HREF='$default->owl_root_url/dbmodify.php?sess=$sess&expand=$expand&action=folder_monitor&order=$order&sortname=$sortname&id=" . $folder_id . "&parent=" . $parent . "'><IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/icon_action/monitor.gif' BORDER=0 ALT='$owl_lang->alt_monitor' TITLE='$owl_lang->alt_monitor'></A><img src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/x_clear.gif' height=1 width=4>");
            } 
            else
            {
               print("<A HREF='$default->owl_root_url/dbmodify.php?sess=$sess&expand=$expand&action=folder_monitor&order=$order&sortname=$sortname&id=" . $folder_id . "&parent=" . $parent . "'><IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/icon_action/monitored.gif' BORDER=0 ALT='$owl_lang->alt_monitored' TITLE='$owl_lang->alt_monitored'></A><img src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/x_clear.gif' height=1 width=4>");
            } 
         } 
      } 
      if (check_auth($sql->f("id"), "folder_modify", $userid) == 1)
      {
         print("<IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/16x16.gif' BORDER=0><img src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/x_clear.gif' height=1 width=4>");
         print("<A HREF='download.php?sess=$sess&id=" . $sql->f("id") . "&parent=" . $sql->f("parent") . "&action=folder&binary=1'><IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/icon_filetype/zip.gif' BORDER=0 ALT='$owl_lang->alt_get_file' TITLE='$owl_lang->alt_get_file'></A><img src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/x_clear.gif' height=1 width=4>");
      } 

      print("</TD>\n");
      if ($default->owl_version_control == 1)
         print ("<TD>&nbsp</TD>\n");
      print("</TR>\n");
   } 
   else
   {
      if ($default->owl_version_control == 1)
      {
         print("\t\t\t\t<TD>&nbsp;</TD>\n<TD>&nbsp;</TD>\n<TD>&nbsp;</TD>\n<TD>&nbsp;</TD>\n");
      } 
      else
      {
         print("\t\t\t\t<TD>&nbsp;</TD>\n<TD>&nbsp;</TD>\n<TD>&nbsp;</TD>\n");
      } 
      // begin Daphne change
      // extra column width for "held" column which folders don't need
      if ($default->owl_version_control == 1)
      {
         if ($PrintLines == 0)
            print ("<TD BGCOLOR='$default->table_cell_bg_alt'>&nbsp;</TD>\n");
         else
            print ("<TD BGCOLOR='$default->table_cell_bg'>&nbsp;</TD>\n");
      } 
      // end Daphne change
      print("</TR>\n");
   } 
} 

if ($default->owl_LookAtHD != "false")
{
   $DBFolders[$DBFolderCount + 1] = "[END]"; //end DBfolder array
   $RefreshPage = CompareDBnHD('folder', $default->owl_FileDir . "/" . get_dirpath($parent), $DBFolders, $parent, $default->owl_folders_table);
} 

//*************************************
// BEGIN Print Files
//*************************************
// 

$DBFileCount = 0;

$sql = new Owl_DB;

if ($default->owl_version_control == 1 && ! $default->owl_use_fs)
{
   $sql->query("select f1.*, f1.major_revision+(f1.minor_revision/10) as mval from $default->owl_files_table  as f1, $default->owl_files_table  as f2 where f1.name=f2.name AND f1.parent=f2.parent AND f1.parent=$parent group by f1.id having mval=max(f2.major_revision+(f2.minor_revision/10)) order by f1.$order $sort");
} 
else
{
   if ($order == "major_minor_revision")
   {
      $order_clause = "major_revision $sort, minor_revision $sort";
   }
   else
   {
      $order_clause = "$order $sort";
   }

   $sLimit = "";

   if ($default->records_per_page > 0)
   {
      $iNumFilesPerPage = $default->records_per_page - $iNumberFoldersDisplayed;
      $sLimit = "LIMIT $nextfiles,$iNumFilesPerPage";

      $sql->query("select * from $default->owl_files_table where parent = '$parent'");
      while ($sql->next_record())
      {
         $DBFileCount++; //count number of filez in db 2 use with array
         $DBFiles[$DBFileCount] = $sql->f("filename"); //create list if files in
      }
   }

   // Query TO retreive the Folders in the current Folder
   $sql->query("select * from $default->owl_files_table where parent = '$parent' order by $order_clause $sLimit");
 
   if ($default->records_per_page > 0)
   {
      if ($iNumFilesPerPage != $default->records_per_page)
      {
         $nextfiles = $nextfiles - $iNumberFoldersDisplayed;
      }
   }
} 
// Looping out files from DB!

while ($sql->next_record())
{
   $bPrintNew = false;
   $bPrintUpdated = false;
   $bFileDownload = check_auth($sql->f("id"), "file_download", $userid);
   if ($default->restrict_view == 1)
   {
      if (!$bFileDownload)
      {
         if ($default->records_per_page == 0)
         {
            $DBFileCount++; //count number of filez in db 2 use with array
            $DBFiles[$DBFileCount] = $sql->f("filename"); //create list if files in
         }
         continue;
      } 
   } 
   // 
   // Find New files
   // 
   if ($bFileDownload == 1)
   {
      if ($sql->f("created") > $lastlogin)
      {
         $bPrintNew = true;
      } 
      if ($sql->f("smodified") > $lastlogin && $sql->f("created") < $lastlogin)
      {
         $bPrintUpdated = true;
      } 
   } 
   $bHasComments = true;
   $CheckComments = new Owl_DB;
   $CheckComments->query("SELECT * from $default->owl_comment_table where fid = '" . $sql->f("id") . "'");
   if ($CheckComments->num_rows() == 0)
   {
      $bHasComments = false;
   } 

   $CountLines++;
   $PrintLines = $CountLines % 2;
   if ($PrintLines == 0)
      print("\t\t\t\t<TR BGCOLOR='$default->table_cell_bg_alt'>");
   else
      print("\t\t\t\t<TR BGCOLOR='$default->table_cell_bg'>");
   print("<TD ALIGN=LEFT>");
   if ($default->hide_bulk == 0)
   {
      if ($sess != "0" || ($sess == "0" && $default->anon_ro == 0))
      {
         print("<INPUT TYPE=CHECKBOX NAME=batch[] VALUE=" . $sql->f("id") . ">");
      } 
   } 
   $sPopupDescription = ereg_replace("\n", '<BR>', $sql->f("description"));
   $sPopupDescription = ereg_replace("\"", "'", $sPopupDescription);
   $sPopupDescription = ereg_replace("'", "\\'", $sPopupDescription);
   $sPopupDescription = ereg_replace("
", "", $sPopupDescription);
   $sPopupDescription = ereg_replace("\r", '', $sPopupDescription);

   if ($sPopupDescription == "") 
   {
      $sPopupDescription = $owl_lang->no_description;
   }
   print("\n<A CLASS='Text' HREF='view.php?sess=$sess&action=file_details&id=" . $sql->f("id") . "&parent=$parent&expand=$expand&order=$order&sortname=$sort'");
   print(" onmouseover=" . '"' . "return makeTrue(domTT_activate(this, event, 'statusText', ' ', 'caption', '" . $owl_lang->description . "', 'content', '" . $sPopupDescription . "', 'trail', true));" . '"');

   print(">\n");
   print("\n");

   $iconfiles = array("html", "htm", "gif", "jpg", "bmp", "zip", "tar", "doc", "mdb", "xls", "ppt", "pdf", "gz", "mp3", "tgz", "avi", "cpt", "eml", "mov" . "rar", "txt" . "bat", "drv", "exe", "mpeg", "reg", "wav", "cdr", "dwg", "ini", "psd", "ttf");
   $choped = split("\.", $sql->f("filename"));
   $pos = count($choped);
   if ( $pos > 1 )
   {
      $ext = strtolower($choped[$pos-1]);
   }
   else
   {
      $ext = "NoExtension";
   }

   $sDispIcon = $ext;

   if (($ext == "gz") && ($pos > 2))
   {
      $exttar = strtolower($choped[$pos-2]);
      if (strtolower($choped[$pos-2]) == "tar")
         $ext = "tar.gz";
   } 

   if ($sql->f("url") == "1")
      print("<IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/icon_filetype/url.gif' BORDER=0>&nbsp;");
   else
   {
      if (preg_grep("/$sDispIcon/", $iconfiles))
      {
         print("<IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/icon_filetype/$sDispIcon.gif' BORDER=0>&nbsp;");
      } 
      else
      {
         print("<IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/icon_filetype/file.gif' BORDER=0>&nbsp;");
      } 
   } 
   if ($fileid == $sql->f("id"))
   {
      print("<B class='hilite'>" . $sql->f("name") . "</B></A>");
   }
   else
   {
      print $sql->f("name") . "</A>";
   } 
   print("</TD>\n");
   print("<TD align='left' nowrap>");

   if ($bHasComments)
   {
      print("<A HREF='$default->owl_root_url/modify.php?sess=$sess&expand=$expand&action=file_comment&order=$order&sortname=$sortname&id=" . $sql->f("id") . "&parent=" . $parent . "'><IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/icon_action/comment.gif' BORDER=0 ALT='$owl_lang->alt_comments' TITLE='$owl_lang->alt_comments'></A>");
   } 
   if ($default->anon_user <> $userid)
   {
      if ($bPrintNew)
      {
         print("<B class='hilite'><IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_icons/new.gif' BORDER=0><FONT COLOR=darkblue>&nbsp;$owl_lang->new_file</FONT></B>");
      } 
      if ($bPrintUpdated)
      {
         print("<B class='hilite'><IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_icons/updated.gif' BORDER=0><FONT COLOR=darkblue>&nbsp;$owl_lang->updated_file</FONT></B>");
      } 
   } 
   print("</TD>\n"); 
   // Begin Daphne Change
   // print version numbers if version control used
   if ($default->owl_version_control == 1)
   {
      if ($fileid == $sql->f("id"))
      {
         print("\n<TD ALIGN=LEFT><B class='hilite'>" . $sql->f("major_revision") . "." . $sql->f("minor_revision") . "</B></td>");
      }
      else
      {
         print("\n<TD ALIGN=LEFT>" . $sql->f("major_revision") . "." . $sql->f("minor_revision") . "</td>");
      }
   } 
   // end Daphne Change
   if ($sql->f("url") == "1")
   {
      if ($fileid == $sql->f("id"))
      {
         if ($bFileDownload == 1)
         {
            print("\n<TD ALIGN=LEFT><A CLASS='Text' HREF='" . $sql->f("filename") . "' TARGET=new TITLE='$owl_lang->title_browse_site'><B class='hilite'>" . $sql->f("name") . " </B></A></TD><TD ALIGN=RIGHT><B class='hilite'>&nbsp</B></TD>");
         } 
         else
         {
            print("\n<TD ALIGN=LEFT>" . $sql->f("name") . "</TD><TD ALIGN=RIGHT><B class='hilite'>&nbsp</B></TD>");
         } 
      } 
      else
      {
         if ($bFileDownload == 1)
         {
            print("\n<TD ALIGN=LEFT><A CLASS='Text' HREF='" . $sql->f("filename") . "' TARGET=new TITLE='$owl_lang->title_browse_site'>" . $sql->f("name") . " </A></TD><TD ALIGN=RIGHT>&nbsp</TD>");
         } 
         else
         {
            print("\n<TD ALIGN=LEFT>" . $sql->f("name") . "</TD><TD ALIGN=RIGHT>&nbsp</TD>");
         } 
      } 
   }
   else
   {
      if ($fileid == $sql->f("id"))
      {
         print("\n<TD ALIGN=LEFT><A CLASS='Text' HREF='download.php?sess=$sess&id=" . $sql->f("id") . "&parent=" . $sql->f("parent") . "' TITLE='$owl_lang->title_download_view'><B class='hilite'>" . $sql->f("filename") . "</A></TD><TD ALIGN=RIGHT><B class='hilite'>" . gen_filesize($sql->f("size")) . "</B></TD>");
      }
      else
      {
         print("\n<TD ALIGN=LEFT><A CLASS='Text' HREF='download.php?sess=$sess&id=" . $sql->f("id") . "&parent=" . $sql->f("parent") . "' TITLE='$owl_lang->title_download_view'>" . $sql->f("filename") . "</A></TD><TD ALIGN=RIGHT>" . gen_filesize($sql->f("size")) . "</TD>");
      }

      if ($default->records_per_page == 0)
      {
         $DBFileCount++; //count number of filez in db 2 use with array
         $DBFiles[$DBFileCount] = $sql->f("filename"); //create list if files in
      }
   }
   if ($expand == 1)
   {
      if ($fileid == $sql->f("id"))
      {
         print("\t\t\t\t<TD ALIGN=LEFT><B class='hilite'>" . fid_to_creator($sql->f("id")) . "</B></TD><TD ALIGN=left><B class='hilite'>" . date($owl_lang->localized_date_format, strtotime($sql->f("smodified"))) . "</B></TD>");
      }
      else
      {
         print("\t\t\t\t<TD ALIGN=LEFT>" . fid_to_creator($sql->f("id")) . "</TD><TD ALIGN=left>" . date($owl_lang->localized_date_format, strtotime($sql->f("smodified"))) . "</TD>");
      }
      print("\t\t\t\t<TD ALIGN=LEFT nowrap>");

      printFileIcons($sql->f("id"), $sql->f("filename"), $sql->f("checked_out"), $sql->f("url"), $default->owl_version_control, $ext, $parent, $is_backup_folder);
   } 
   if ($default->owl_version_control == 1)
   {
      if (($holder = uid_to_name($sql->f("checked_out"))) == "Owl")
      {
         print("\t<TD ALIGN=center>-</TD></TR>");
      } 
      else
      {
         print("\t<TD align=left>$holder</TD></TR>");
      } 
   } 
} 

   $DBFiles[$DBFileCount + 1] = "[END]"; //end DBfile array
   
   print("</TABLE>");
   // *******************************
   // If the refresh from hard drive
   // feature is enabled
   // *******************************
   // 
   if ($default->owl_use_fs)
   {
      if ($default->owl_LookAtHD != "false")
      {
         if ($RefreshPage == true)
         {
            CompareDBnHD('file', $default->owl_FileDir . "/" . get_dirpath($parent), $DBFiles, $parent, $default->owl_files_table);
         } 
         else
         {
            $RefreshPage = CompareDBnHD('file', $default->owl_FileDir . "/" . get_dirpath($parent), $DBFiles, $parent, $default->owl_files_table);
         } 
         if ($RefreshPage == true)
         {

?>
<script language="javascript">
     window.location.reload(true);
   </script>
<?php
         } 
      } 
   } 
   print('<script language="JavaScript" type="text/javascript">
<!-- 
function CheckAll() {
  for (var i = 0; i < document.FileList.elements.length; i++) {
    if(document.FileList.elements[i].type == "checkbox"){
      document.FileList.elements[i].checked =         !(document.FileList.elements[i].checked);
    }
  }
}
//-->
</script>');

   if ($default->status_bar_location == 1 || $default->status_bar_location == 2)
   {
         fPrintStatusBar($nextfolders, $nextfiles, $bDisplayFiles, $iFileCount, $iCurrentPage);
   } 

   print("</FORM>\n");
   include(_SYSCOMMONROOT . "/lib/footer.inc");

?>
