<?php

/**
 * move.php
 * 
 * Copyright (c) 1999-2003 The Owl Project Team
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 * 
 * $Id: move.php,v 1.4 2003/11/12 14:25:09 b0zz Exp $
 */

//require_once("./config/owl.php");
require_once(_SYSCOMMONROOT . "/lib/disp.lib.php");
require_once(_SYSCOMMONROOT . "/lib/owl.lib.php");
require_once(_SYSCOMMONROOT . "/lib/security.lib.php");

if ($sess == "0" && $default->anon_ro == 1)
   printError($owl_lang->err_login);

if (isset($myaction_x))
{
   $myaction = "$owl_lang->cancel_button";
} 

global $order, $sortorder, $sortname;
switch ($order)
{
   case "name":
      $sortorder = 'sortname';
      break;
   case "major_revision":
      $sortorder = 'sortver';
      break;
   case "filename" :
      $sortorder = 'sortfilename';
      break;
   case "size" :
      $sortorder = 'sortsize';
      break;
   case "creatorid" :
      $sortorder = 'sortposted';
      break;
   case "smodified" :
      $sortorder = 'sortmod';
      break;
   case "checked_out":
      $sortorder = 'sortcheckedout';
      break;
   default:
      break;
} 
if ($myaction == "$owl_lang->cancel_button")
{
   displayBrowsePage($parent);
   exit();
} 

if ($action == "file")
{
   if (check_auth($id, "file_modify", $userid) == 0)
   {
      include(_SYSCOMMONROOT . "/lib/header.inc");
      include(_SYSCOMMONROOT . "/lib/userheader.inc");
      printError($owl_lang->err_nofilemod);
   } 
} elseif ($action == "bulk_move")
{
   $disp = unserialize(stripslashes($id));
} 
else
{
   if (check_auth($id, "folder_modify", $userid) == 0)
   {
      include(_SYSCOMMONROOT . "/lib/header.inc");
      include(_SYSCOMMONROOT . "/lib/userheader.inc");
      printError($owl_lang->err_nofilemod);
   } 
} 

function checkForNewFolder()
{
   global $HTTP_POST_VARS, $newFolder;
   if (!is_array($HTTP_POST_VARS)) return;
   while (list($key, $value) = each ($HTTP_POST_VARS))
   {
      if (substr($key, 0, 2) == "ID")
      {
         $newFolder = intval(substr($key, 2));
         break;
      } 
   } 
} 

function showFoldersIn($fid, $folder)
{
   global $folderList, $fCount, $fDepth, $excludeID, $action, $id, $default, $userid ; 
   // If restricted view is in effect only show the folders you do have access to
   $showfolder = 1;
   if ($default->restrict_view == 1)
      if (check_auth($fid, "folder_modify", $userid) != 0 && $fid != 0)
         $showfolder = 1;
      else
         $showfolder = 0;

      if ($showfolder == 1)
      {
         for ($c = 0 ;$c < ($fDepth-1) ; $c++) print "<img src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/blank.gif' align=top>";
         if ($fDepth) print "<img src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/link.gif' align=top>";

         $gray = 0; //	Work out when to gray out folders ...
         if ($fid == $excludeID) $gray = 1; //	current parent for all moves
         if (($action == "folder") && ($fid == $id)) $gray = 1; //	subtree for folder moves
         if (check_auth($fid, "folder_modify", $userid) == 0)
         {
            $gray = 1; //	check for permissions
         } 

         if ($gray)
         {
            print "<img src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/icon_filetype/folder_gray.gif' align=top>";
            print " <font color=\"silver\">$folder</font><br>\n";
         } 
         else
         {
            print "<input type='image' border=0 src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/icon_filetype/folder_closed.gif' align=top name=\"ID";
            print "$fid\"> $folder<br>\n";
         } 
      } 
      if (($action == "folder") && ($fid == $id)) return; //	Don't show subtree of selected folder as target for folder move
      for ($c = 0; $c < $fCount; $c++)
      {
         if ($folderList[$c][2] == $fid)
         {
            $fDepth++;
            showFoldersIn($folderList[$c][0] , $folderList[$c][1]);
            $fDepth--;
         } 
      } 
   } 

   checkForNewFolder();
   if (isset($newFolder))
   {
      $sql = new Owl_DB;

      $source = "";
      $fID = $parent;
      do
      {
         $sql->query("select name,parent from $default->owl_folders_table where id='$fID'");
         while ($sql->next_record())
         {
            $tName = $sql->f("name");
            $fID = $sql->f("parent");
         } 
         $source = $tName . "/" . $source;
      } 
      while ($fID != 0);

      $dest = "";
      $fID = $newFolder;
      do
      {
         $sql->query("select name,parent from $default->owl_folders_table where id='$fID'");
         while ($sql->next_record())
         {
            $tName = $sql->f("name");
            $fID = $sql->f("parent");
         } 
         $dest = $tName . "/" . $dest;
      } 
      while ($fID != 0);

      if ($action == "file")
      {
         $sql = new Owl_DB;
         $sql->query("select filename, parent from $default->owl_files_table where id = '$id'");
         while ($sql->next_record())
         {
            $fname = $sql->f("filename");
            $parent = $sql->f("parent");
         } 
      } elseif ($action == "folder")
      {
         $sql = new Owl_DB;
         $sql->query("select name, parent from $default->owl_folders_table where id='$id'");
         while ($sql->next_record())
         {
            $fname = $sql->f("name");
            $parent = $sql->f("parent");
         } 
      } 

      if ($action == "bulk_move")
      {
         foreach($disp as $fid)
         {
            if (check_auth($fid, "file_modify", $userid) == 1)
            {
               if ($default->owl_use_fs)
               {
                  $sql = new Owl_DB;
                  $sql->query("select filename, parent, url from $default->owl_files_table where id = '$fid'");
                  while ($sql->next_record())
                  {
                     $fname = $sql->f("filename");
                     $parent = $sql->f("parent");
                     if ($sql->f("url") == 1)
                     {
                        $type = "url";
                     } 
                     else
                     {
                        $type = "";
                     } 
                  } 
                  if ($type != "url")
                  {
                     if (!file_exists("$default->owl_FileDir/$dest$fname"))
                     {
                        if (substr(php_uname(), 0, 7) != "Windows")
                        {
                           $cmd = "mv \"$default->owl_FileDir/$source$fname\" \"$default->owl_FileDir/$dest\" 2>&1";
                           $lines = array();
                           $errco = 0;
                           $result = myExec($cmd, $lines, $errco);
                           if ($errco != 0)
                           {
                              printError($owl_lang->err_movecancel, $result);
                           } 
                        } 
                        else
                        { 
                           // IF Windows just do a rename and hope for the best
                           rename ("$default->owl_FileDir/$source$fname", "$default->owl_FileDir/$dest/$fname");
                        } 
                     } 
                     else
                     {
                        printError($owl_lang->err_fileexists, $result);
                     } 
                  } 
               } 
               $sql->query("update $default->owl_files_table set parent='$newFolder' where id='$fid'");
               owl_syslog(FILE_MOVED, $userid, flid_to_filename($fid), $parent, $owl_lang->log_file_to . fid_to_name($newFolder), "FILE");
            } 
         } 
      } 
      else
      {
         if ($default->owl_use_fs)
         {
            if ($type != "url")
            {
               if (!file_exists("$default->owl_FileDir/$dest$fname"))
               {
                  if (substr(php_uname(), 0, 7) != "Windows")
                  {
                     $cmd = "mv \"$default->owl_FileDir/$source$fname\" \"$default->owl_FileDir/$dest\" 2>&1";
                     $lines = array();
                     $errco = 0;
                     $result = myExec($cmd, $lines, $errco);
                     if ($errco != 0)
                        printError($owl_lang->err_movecancel, $result);
                  } 
                  else
                  { 
                     // IF Windows just do a rename and hope for the best
                     rename ("$default->owl_FileDir/$source$fname", "$default->owl_FileDir/$dest/$fname");
                  } 
               } 
               else
                  printError($owl_lang->err_fileexists, $result);
            } 
         } 
      } 

      if ($action == "file")
      {
         $sql->query("update $default->owl_files_table set parent='$newFolder' where id='$id'");
         owl_syslog(FILE_MOVED, $userid, flid_to_filename($id), $parent, $owl_lang->log_file_to . fid_to_name($newFolder), "FILE");
      } elseif ($action == "folder")
      {
         $sql->query("update $default->owl_folders_table set parent='$newFolder' where id='$id'");
         owl_syslog(FOLDER_MOVED, $userid, fid_to_name($id), $parent, $owl_lang->log_file_to . fid_to_name($newFolder), "FILE");
      } 
      // if we deleted something that was in the backup directory
      // we want to display the Parent Directory when we are done
      displayBrowsePage($parent);
   } 
   // First time through. Generate screen for selecting target directory
   include(_SYSCOMMONROOT . "/lib/header.inc");
   include(_SYSCOMMONROOT . "/lib/userheader.inc");
   print("<TABLE WIDTH='$default->table_expand_width' BGCOLOR='$default->main_header_bgcolor' CELLSPACING='0' CELLPADDING='0' BORDER='$default->table_border' HEIGHT='$default->table_header_height'>\n");

   ?>
<TR><TD ALIGN=LEFT>
<?php
   fPrintPrefs();

   ?> 
<FONT SIZE=-1>

<?php 
fPrintButton("index.php?login=logout&sess=$sess", "btn_logout");
?>
    </FONT></TD><TD ALIGN=RIGHT>
<?php 
fPrintButton("browse.php?sess=$sess&parent=$parent&expand=$expand&order=$order&$sortorder=$sortname", "btn_browse");
?>
        </TD></TR></TABLE>
<?php

   print("<CENTER>"); 
   // Get information about file or directory we want to move
   if ($action == "file")
   {
      $sql = new Owl_DB;
      $sql->query("select filename, parent from $default->owl_files_table where id='$id'");
   } elseif ($action == "bulk_move")
   {
      $sql = new Owl_DB;
      $query = "select * from $default->owl_files_table where ";
      foreach($disp as $fid)
      {
         if (check_auth($fid, "file_modify", $userid) == 1)
         {
            $query .= "id = '" . $fid . "' or ";
         } 
      } 
      $query .= "id = " . $fid . " and 1=1";
      $sql->query("$query");
   } 
   else
   {
      $sql = new Owl_DB;
      $sql->query("select name, parent from $default->owl_folders_table where id='$id'");
   } 
   print("<BR>\n");
   while ($sql->next_record())
   {
      if ($action == "file" || $action == "bulk_move") $fname = $sql->f("filename");
      if ($action == "folder") $fname = $sql->f("name");
      $parent = $sql->f("parent");
      print "<font size=1>$owl_lang->moving $fname.<BR>";
   } 
   print "<BR>$owl_lang->select</font>";

   ?>
<div align="center">
<form method="POST">
<input type="hidden" name="parent" value="<?php print $parent; ?>">
<input type="hidden" name="expand" value="<?php print $expand; ?>">
<input type="hidden" name="order" value="<?php print $order; ?>">
<input type="hidden" name="action" value="<?php print $action; ?>">
<input type="hidden" name="myaction" value="<?php print $myaction; ?>">
<input type="hidden" name="fname" value="<?php print $fname; ?>">
<input type="hidden" name="id" value="<?php print $id; ?>">
<table cellspacing=0 border=1 cellpadding=4><tr><td align=left><p>

<?php 
   // Get list of folders sorted by name
   $whereclause = "";

   if ($default->hide_backup == 1 && ($usergroupid != "0" || $usergroupid != $default->file_admin_group))
   {
      $whereclause = " WHERE name <> 'backup'";
   } 

   $sql->query("select id,name,parent from $default->owl_folders_table $whereclause order by name");

   $i = 0;
   while ($sql->next_record())
   {
      $folderList[$i][0] = $sql->f("id");
      $folderList[$i][1] = $sql->f("name");
      $folderList[$i][2] = $sql->f("parent");
      $i++;
   } 

   $fCount = count($folderList);

   $fDepth = 0;
   $excludeID = $parent; // current location should not be a offered as a target
   showFoldersIn(1, fid_to_name("1"));

   print("</p></td></tr></table>");
   print("<br>");
   print("<input TYPE='image' name='myaction' SRC='$default->owl_graphics_url/$language/graphics/$default->sButtonStyle/ui_buttons/btn_cancel.gif' BORDER=0 ALT='$owl_lang->alt_cancel_move' TITLE='$owl_lang->alt_cancel_move' onMouseOver=this.src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_buttons/btn_cancel_hover.gif'; onMouseOut=this.src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_buttons/btn_cancel.gif'; VALUE='$owl_lang->cancel_button'>");
   print("</form>");
   print("</div>");

   include(_SYSCOMMONROOT . "/lib/footer.inc");

?>
