<?php
/**
 * showrecords.php -- Browse page
 * 
 * Copyright (c) 1999-2003 The Owl Project Team
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 */

require_once("./config/owl.php");
require_once(_SYSCOMMONROOT . "/lib/disp.lib.php");
require_once(_SYSCOMMONROOT . "/lib/owl.lib.php");
require_once(_SYSCOMMONROOT . "/lib/readhd.php");
require_once(_SYSCOMMONROOT . "/lib/security.lib.php");
include_once(_SYSCOMMONROOT . "/lib/header.inc");
include_once(_SYSCOMMONROOT . "/lib/userheader.inc");

if ($default->anon_user == $userid)
{
   die("$owl_lang->err_unauthorized");
} 

if (!isset($parent) || $parent == "") $parent = "1";
if (!isset($expand)) $expand = $default->expand;
if (!isset($order)) $order = "name";
if (!isset($sortname)) $sortname = "ASC";
if (!isset($sortver)) $sortver = "ASC, minor_revision ASC";
if (!isset($sortcheckedout)) $sortcheckedout = "ASC";
if (!isset($sortfilename)) $sortfilename = "DESC";
if (!isset($sortsize)) $sortsize = "DESC";
if (!isset($sortposted)) $sortposted = "DESC";
if (!isset($sortmod)) $sortmod = "DESC";
if (!isset($sort)) $sort = "asc";

switch ($order)
{
   case "name":
      $sortorder = 'sortname';
      $sort = $sortname;
      break;
   case "major_minor_revision":
      $sortorder = 'sortver';
      $sort = $sortver;
      break;
   case "filename" :
      $sortorder = 'sortfilename';
      $sort = $sortfilename;
      break;
   case "size" :
      $sortorder = 'sortsize';
      $sort = $sortsize;
      break;
   case "creatorid" :
      $sortorder = 'sortposted';
      $sort = $sortposted;
      break;
   case "smodified" :
      $sortorder = 'sortmod';
      $sort = $sortmod;
      break;
   case "checked_out":
      $sortorder = 'sortcheckedout';
      $sort = $sortcheckedout;
      break;
   default:
      $sort = "ASC";
      break;
} 
if (check_auth($parent, "folder_view", $userid) != "1")
{
   printError($owl_lang->err_nofolderaccess);
   exit;
} 

$getlastlogin = new Owl_DB;
$getlastlogin->query("SELECT lastlogin FROM $default->owl_users_table where id = '" . $userid . "'");
$getlastlogin->next_record();
$lastlogin = $getlastlogin->f("lastlogin");

print("<TABLE WIDTH='$default->table_expand_width' BGCOLOR='$default->main_header_bgcolor' CELLSPACING='0' CELLPADDING='0' BORDER='$default->table_border' HEIGHT='40'>\n");

?>
<TR><TD ALIGN=LEFT> 
<?php
fPrintPrefs();

?> 

<FONT SIZE=-1>
<?php
if (!$sess == "0")
{
   fPrintButton("index.php?login=logout&sess=$sess", "btn_logout");
} 
else
{
   fPrintButton("index.php?login=1", "btn_login");
} 

?>
    </FONT></TD>
    <TD ALIGN=RIGHT> 
<?php
if (check_auth($parent, "folder_modify", $userid) == 1)
{
   fPrintButton("browse.php?sess=$sess&parent=$parent&expand=$expand&order=$order&$sortorder=$sortname", "btn_browse");
} 

print("</TD></TR></TABLE>\n");

print("<CENTER>\n");
if ($expand == 1)
{
   print("\t\t<TABLE WIDTH=$default->table_expand_width BORDER=$default->table_border>\n");
} 
else
{
   print("\t\t<TABLE WIDTH=$default->table_collapse_width BORDER=$default->table_border>\n");
} 

print("\t\t\t<TR><TD></TD></TR>\n");
print("\t\t\t<TR><TD align=left>&nbsp;</TD></TR></TABLE>\n");

if ($expand == 1)
{
   print("\t\t<HR WIDTH=$default->table_expand_width>\n");
} 
else
{
   print("\t\t<HR WIDTH=$default->table_collapse_width>\n");
} 

if ($expand == 1)
{
   print("\t\t\t<TABLE WIDTH=$default->table_expand_width BORDER=$default->table_border>\n<TR BGCOLOR='$default->table_header_bg'>\n");
   show_link("name", "sortname", $sortname, $order, $sess, $expand, $parent, $owl_lang->title); 
   if ($default->owl_version_control == 1)
   {
      show_link("major_minor_revision", "sortver", $sortver, $order, $sess, $expand, $parent, $owl_lang->ver);
   } 
   show_link("filename", "sortfilename", $sortfilename, $order, $sess, $expand, $parent, $owl_lang->file);
   show_link("size", "sortsize", $sortsize, $order, $sess, $expand, $parent, $owl_lang->size);
   show_link("creatorid", "sortposted", $sortposted, $order, $sess, $expand, $parent, $owl_lang->postedby);
   show_link("smodified", "sortmod", $sortmod, $order, $sess, $expand, $parent, $owl_lang->modified);
   print("<TD align=left>$owl_lang->actions</TD>\n"); 
   if ($default->owl_version_control == 1)
   {
      show_link("checked_out", "sortcheckedout", $sortcheckedout, $order, $sess, $expand, $parent, $owl_lang->held);
   } 
} 
else
{
   print("\t\t\t<TABLE WIDTH=$default->table_collapse_width BORDER=$default->table_border><TR BGCOLOR='$default->table_header_bg'>\n");
   show_link("name", "sortname", $sortname, $order, $sess, $expand, $parent, $owl_lang->title); 
   if ($default->owl_version_control == 1)
   {
      show_link("major_minor_revision", "sortver", $sortver, $order, $sess, $expand, $parent, $owl_lang->ver);
   } 
   show_link("filename", "sortfilename", $sortfilename, $order, $sess, $expand, $parent, $owl_lang->file);
   show_link("size", "sortsize", $sortsize, $order, $sess, $expand, $parent, $owl_lang->size); 
   if ($default->owl_version_control == 1)
   {
      show_link("checked_out", "sortcheckedout", $sortcheckedout, $order, $sess, $expand, $parent, $owl_lang->held);
   } 
} 
// 
// BEGIN Print Files
// 
$sql = new Owl_DB;

if ($order == "major_minor_revision")
{
   $order_clause = "major_revision $sort, minor_revision $sort";
}
else
{
   $order_clause = "$order $sort";
}
if ($type == "n")
{
   $sql->query("SELECT * FROM $default->owl_files_table where created > '$lastlogin' order by $order_clause");
} elseif ($type == "u")
{
   $sql->query("SELECT * FROM $default->owl_files_table where smodified > '$lastlogin' and created < '$lastlogin' order by $order_clause ");
} elseif ($type == "m")
{
   $sql->query("SELECT * FROM $default->owl_files_table where creatorid = '$userid' order by $order_clause ");
} 
// Looping out files from DB!
print("<FORM name='FileList' enctype='multipart/form-data' ACTION='dbmodify.php' METHOD=POST>");

while ($sql->next_record())
{
   $bPrintNew = false;
   $bPrintUpdated = false;
   // Tiian change 2003-07-31
   $sDirectoryPath = get_dirpath($sql->f("parent"));
   $pos = strpos($sDirectoryPath, "backup");
   if (is_integer($pos) && $pos)
   {
      $is_backup_folder = true;
   }
   else
   {
      $is_backup_folder = false;
   }

   if ($type == "n")
   {
      $sDirectoryPath = get_dirpath($sql->f("parent"));
      $pos = strpos($sDirectoryPath, "backup");
      if (is_integer($pos) && $pos)
      {
         continue;
      } 
   } 

   if ($default->restrict_view == 1)
   {
      if (!check_auth($sql->f("id"), "file_download", $userid))
         continue;
   } 
   // 
   // Find New files
   // 
   if (check_auth($sql->f("id"), "file_download", $userid) == 1)
   {
      if ($sql->f("created") > $lastlogin)
      {
         $bPrintNew = true;
         $iNewFileCount++;
      } 
      if ($sql->f("smodified") > $lastlogin && $sql->f("created") < $lastlogin)
      {
         $bPrintUpdated = true;
         $iUpdatedFileCount++;
      } 
   } 

   $CountLines++;
   $PrintLines = $CountLines % 2;
   if ($PrintLines == 0)
      print("\t\t\t\t<TR BGCOLOR='$default->table_cell_bg_alt'>");
   else
      print("\t\t\t\t<TR BGCOLOR='$default->table_cell_bg'>");
   print("<TD ALIGN=LEFT>");

   $sPopupDescription = ereg_replace("\n", '<BR>', $sql->f("description"));
   $sPopupDescription = ereg_replace("\"", "'", $sPopupDescription);
   $sPopupDescription = ereg_replace("'", "\\'", $sPopupDescription);
   $sPopupDescription = ereg_replace("
", "<BR>", $sPopupDescription);
   $sPopupDescription = ereg_replace("\r", '', $sPopupDescription);

   print("\n<A HREF='view.php?sess=$sess&action=file_details&id=" . $sql->f("id") . "&parent=$parent&expand=$expand&order=$order&sortname=$sort'");
   print("         onmouseover=" . '"' . "return makeTrue(domTT_activate(this, event, 'statusText', 'Click The File For Full Details', 'caption', '" . $owl_lang->description . "', 'content', '" . $sPopupDescription . "', 'trail', true));" . '"');
   print(">\n");
   $iconfiles = array("html", "htm", "gif", "jpg", "bmp", "zip", "tar", "doc", "mdb", "xls", "ppt", "pdf", "gz", "mp3", "tgz", "avi", "cpt", "eml", "mov" . "rar", "txt" . "bat", "drv", "exe", "mpeg", "reg", "wav", "cdr", "dwg", "ini", "psd", "ttf");
   $choped = split("\.", $sql->f("filename"));
   $pos = count($choped);
   if ( $pos > 1 )
   {
      $ext = strtolower($choped[$pos-1]);
   }
   else
   {
      $ext = "NoExtension";
   }

   if ($sql->f("url") == "1")
      print("<IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/icon_filetype/url.gif' BORDER=0>&nbsp;");
   else
   {
      if (preg_grep("/$ext/", $iconfiles))
         print("<IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/icon_filetype/$ext.gif' BORDER=0>&nbsp;");
      else
         print("<IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/icon_filetype/file.gif' BORDER=0>&nbsp;");
   } 
   if ($fileid == $sql->f("id"))
      print("<B>" . $sql->f("name") . "</B></A>");
   else
   {
      print $sql->f("name") . "</A>";
   } 
   if ($bPrintNew)
   {
      print("&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<B><IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_icons/new.gif' BORDER=0><FONT COLOR=darkblue>&nbsp;$owl_lang->new_file</FONT></B>");
   } 
   if ($bPrintUpdated)
   {
      print("&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<B><IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_icons/updated.gif' BORDER=0><FONT COLOR=darkblue>&nbsp;$owl_lang->updated_file</FONT></B>");
   } 
   print("</TD>"); 
   // print version numbers if version control used
   if ($default->owl_version_control == 1)
   {
      if ($fileid == $sql->f("id"))
         print("<TD ALIGN=LEFT><B>" . $sql->f("major_revision") . "." . $sql->f("minor_revision") . "<B></td>");
      else
         print("<TD ALIGN=LEFT>" . $sql->f("major_revision") . "." . $sql->f("minor_revision") . "</td>");
   } 
   if ($sql->f("url") == "1")
      if ($fileid == $sql->f("id"))
      {
         print("<TD ALIGN=LEFT><A HREF='" . get_dirpath($sql->f("parent")) . "/" . $sql->f("filename") . "' TARGET=new><B>" . $sql->f("name") . " </B></A></TD><TD ALIGN=RIGHT><B>&nbsp</B></TD>");
      } 
      else
      {
         print("<TD ALIGN=LEFT><A HREF='" . get_dirpath($sql->f("parent")) . "/" . $sql->f("filename") . "' TARGET=new>" . $sql->f("name") . " </A></TD><TD ALIGN=RIGHT>&nbsp</TD>");
      } 
      else
      if ($fileid == $sql->f("id"))
      {
         print("<TD ALIGN=LEFT><A HREF='browse.php?sess=$sess&fileid=" . $sql->f("id") . "&parent=" . $sql->f("parent") . "'><B>" . get_dirpath($sql->f("parent")) . "/" . $sql->f("filename") . "</B></A></TD><TD ALIGN=RIGHT><B>" . gen_filesize($sql->f("size")) . "</B></TD>");
      } 
      else
      {
         print("<TD ALIGN=LEFT><A HREF='browse.php?sess=$sess&fileid=" . $sql->f("id") . "&parent=" . $sql->f("parent") . "'TARGET=new>" . get_dirpath($sql->f("parent")) . "/" . $sql->f("filename") . "</A></TD><TD ALIGN=RIGHT>" . gen_filesize($sql->f("size")) . "</TD>");
      } 

      if ($expand == 1)
      {
         if ($fileid == $sql->f("id"))
            print("\t\t\t\t<TD ALIGN=LEFT><B>" . fid_to_creator($sql->f("id")) . "</B></TD><TD ALIGN=left><B>" . date($owl_lang->localized_date_format, strtotime($sql->f("smodified"))) . "</B></TD>");
         else
            print("\t\t\t\t<TD ALIGN=LEFT>" . fid_to_creator($sql->f("id")) . "</TD><TD ALIGN=left>" . date($owl_lang->localized_date_format, strtotime($sql->f("smodified"))) . "</TD>");
         print("\t\t\t\t<TD ALIGN=LEFT>");

         printFileIcons($sql->f("id"), $sql->f("filename"), $sql->f("checked_out"), $sql->f("url"), $default->owl_version_control, $ext, $sql->f("parent"),$is_backup_folder);
      } 
      // printing who has a document checked out
      if ($default->owl_version_control == 1)
      {
         if (($holder = uid_to_name($sql->f("checked_out"))) == "Owl")
         {
            print("\t<TD ALIGN=center>-</TD></TR>");
         } 
         else
         {
            print("\t<TD align=left>$holder</TD></TR>");
         } 
      } 
   } 

   print("</TABLE>");
   print("</FORM>\n");
   include(_SYSCOMMONROOT . "/lib/footer.inc");

?>
