<?php

/**
 * view.php
 * 
 * Copyright (c) 1999-2003 The Owl Project Team
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 * 
 * $Id: view.php,v 1.11 2003/11/12 14:25:10 b0zz Exp $
 */

//require_once("./config/owl.php");
require_once(_SYSCOMMONROOT . "/lib/disp.lib.php");
require_once(_SYSCOMMONROOT . "/lib/owl.lib.php");
require_once(_SYSCOMMONROOT . "/lib/security.lib.php");
require_once(_SYSCOMMONROOT . "/phpid3v2/class.id3.php");

if ($sess == "0" && $default->anon_ro == 1)
   printError($owl_lang->err_login);

// BEGIN what Richard Bartz added to show PDF, DOC, and TXT special view
// While I was at it I added xls, mp3, and ppt.

if ($action == "pdf_show" || $action == "xls_show" || $action == "doc_show" || $action == "ppt_show" || $action == "mp3_play")
{
   if (check_auth($id, "file_download", $userid) == 1)
   {
      if ($default->owl_use_fs)
      {
         $path = $default->owl_FileDir . "/" . find_path($parent) . "/" . flid_to_filename($id);
      } 
      else
      {
         $uncomptmpfile = $default->owl_tmpdir . "/owltmp.$id.$sess";
         $getfile = new Owl_DB;
         $getfile->query("select data,compressed from $default->owl_files_data_table where id='$id'");
         while ($getfile->next_record())
         {
            if ($getfile->f("compressed"))
            {
               $tmpfile = $default->owl_tmpdir . "/owltmp.$id.$sess.gz";
               if ($default->debug)
               {
                  if (!file_exists($default->owl_tmpdir))
                  {
                     printError("$owl_lang->debug_tmp_not_exists");
                  } 
                  if (!is_writable($default->owl_tmpdir))
                  {
                     printError("$owl_lang->debug_tmp_not_writeable");
                  } 
               } 
               if (file_exists($tmpfile)) unlink($tmpfile);

               $fp = fopen($tmpfile, "wb");
               fwrite($fp, $getfile->f("data"));
               fclose($fp);

               system($default->gzip_path . " -df $tmpfile");

               $fsize = filesize($uncomptmpfile);
               $fd = fopen($uncomptmpfile, 'rb');
               $filedata = fread($fd, $fsize);
               fclose($fd);
            } 
            else
            {
               $tmpfile = $default->owl_tmpdir . "/owltmp.$id.$sess";
               if ($default->debug)
               {
                  if (!file_exists($default->owl_tmpdir))
                  {
                     printError("$owl_lang->debug_tmp_not_exists");
                  } 
                  if (!is_writable($default->owl_tmpdir))
                  {
                     printError("$owl_lang->debug_tmp_not_writeable");
                  } 
               } 
               if (file_exists($tmpfile)) unlink($tmpfile);

               $fp = fopen($tmpfile, "wb");
               fwrite($fp, $getfile->f("data"));
               fclose($fp);
            } 
         } 
         $path = $uncomptmpfile;
      } 
   } 
   else
   {
      printError($owl_lang->err_nofileaccess);
   } 
} 

if ($action == "pdf_show")
{
   $len = filesize($path);
   header("Content-type: application/pdf");
   header("Content-Length: $len");
   header("Content-Disposition: inline; filename=" . flid_to_filename($id));
   readfile($path);
   if (!$default->owl_use_fs)
   {
      unlink($path);
   } 
   die;
} 

if ($action == "xls_show")
{
   $len = filesize($path);
   header("Content-type: application/ms-excel");
   header("Content-Length: $len");
   header("Content-Disposition: inline; filename=" . flid_to_filename($id));
   readfile($path);
   if (!$default->owl_use_fs)
   {
      unlink($path);
   } 
   die;
} 

if ($action == "doc_show")
{
   $len = filesize($path);
   header("Content-type: application/msword");
   header("Content-Length: $len");
   header("Content-Disposition: inline; filename=" . flid_to_filename($id));
   readfile($path);
   if (!$default->owl_use_fs)
   {
      unlink($path);
   } 
   die;
} 

if ($action == "ppt_show")
{
   $len = filesize($path);
   header("Content-type: application/vnd.ms-powerpoint");
   header("Content-Length: $len");
   header("Content-Disposition: inline; filename=" . flid_to_filename($id));
   readfile($path);
   if (!$default->owl_use_fs)
   {
      unlink($path);
   } 
   die;
} 

if ($action == "mp3_play")
{
   $len = filesize($path);
   header("Content-type: audio/mpeg");
   header("Content-Length: $len");
   header("Content-Disposition: inline; filename=" . flid_to_filename($id));
   readfile($path);
   if (!$default->owl_use_fs)
   {
      unlink($path);
   } 
   die;
} 
// end of what Richard Bartz added to show PDF, DOC, and TXT special view
// cv change for security, should deny documents directory
// added image_show that passes the image through
if ($action != "image_show")
{
   include(_SYSCOMMONROOT . "/lib/header.inc");
   include(_SYSCOMMONROOT . "/lib/userheader.inc");
} 


switch ($order)
{
   case "name":
      $sortorder = 'sortname';
      break;
   case "major_revision":
      $sortorder = 'sortver';
      break;
   case "filename" :
      $sortorder = 'sortfilename';
      break;
   case "size" :
      $sortorder = 'sortsize';
      break;
   case "creatorid" :
      $sortorder = 'sortposted';
      break;
   case "smodified" :
      $sortorder = 'sortmod';
      break;
   case "checked_out":
      $sortorder = 'sortcheckedout';
      break;
   default:
      break;
} 

if ($action == "image_show")
{
   if (check_auth($id, "file_download", $userid) == 1)
   {
      if ($default->owl_use_fs)
      {
         $path = $default->owl_FileDir . "/" . find_path($parent) . "/" . flid_to_filename($id);
         readfile("$path");
      } 
      else
      {
         $sql = new Owl_DB;
         $filename = flid_to_filename($id);
         if ($filetype = strrchr($filename, "."))
         {
            $filetype = substr($filetype, 1);
            $sql->query("select * from $default->owl_mime_table where filetype = '$filetype'");
            while ($sql->next_record()) $mimeType = $sql->f("mimetype");
         } 
         if ($mimeType)
         {
            header("Content-Type: $mimeType");
            $sql->query("select data,compressed from " . $default->owl_files_data_table . " where id='$id'");
            while ($sql->next_record())
            {
               if ($sql->f("compressed"))
               {
                  $tmpfile = $default->owl_tmpdir . "/owltmp.$id";
                  if (file_exists($tmpfile)) unlink($tmpfile);
                  $fp = fopen($tmpfile, "wb");
                  fwrite($fp, $sql->f("data"));
                  fclose($fp);
                  flush(passthru($default->gzip_path . " -dfc $tmpfile"));
                  unlink($tmpfile);
               } 
               else
               {
                  print $sql->f("data");
               } 
            } 
         } 
      } 
   } 
   else
   {
      print($owl_lang->err_nofileaccess);
   } 
   die;
} 
print("<TABLE WIDTH='$default->table_expand_width' BGCOLOR='$default->main_header_bgcolor' CELLSPACING='0' CELLPADDING='0' BORDER='$default->table_border' HEIGHT='$default->table_header_height'>");

?>
<TR><TD ALIGN=LEFT>
<?php
fPrintPrefs();

?> 

<FONT SIZE=-1>

<?php 
fPrintButton("index.php?login=logout&sess=$sess", "btn_logout");
?>
    </FONT></TD><TD ALIGN=RIGHT>
<?php 
fPrintButton("browse.php?sess=$sess&parent=$parent&expand=$expand&order=$order&$sortorder=$sortname", "btn_browse");
?>
	</TD></TR></TABLE>
<?php
if ($action == "file_details")
{
   if (check_auth($parent, "folder_view", $userid) == 1)
   {
      //$expand = 1;
      print("<TABLE WIDTH=$default->table_expand_width BORDER=$default->table_border>");
      print("<TR><TD align=left>");
      $iNewParent = owlfolderparent($parent);
      if ($iNewParent != 0)
      {
         print("<A HREF='browse.php?sess=$sess&parent=$iNewParent&expand=$expand&order=$order&$sortorder=$sort' TITLE='$owl_lang->title_return_folder " . flid_to_name($iNewParent) . "'><img border='0' src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_nav/folder_up.gif' width ='16' height='16'></A>");
      } 
      else
      {
         print("<img border='0' src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_nav/folder_up.gif' width ='16' height='16'>");
      } 
      print(gen_navbar($parent, $id) . "</TD></TR>");

      print("</TABLE><HR WIDTH=$default->table_expand_width><BR>");
      $sql = new Owl_DB;
      $sql->query("select * from $default->owl_files_table where id = '$id'");
      while ($sql->next_record())
      {
         $security = $sql->f("security");
         if ($security == "0") $security = $owl_lang->everyoneread;
         if ($security == "1") $security = $owl_lang->everyonewrite;
         if ($security == "2") $security = $owl_lang->groupread;
         if ($security == "3") $security = $owl_lang->groupwrite;
         if ($security == "4") $security = $owl_lang->onlyyou;
         if ($security == "5") $security = $owl_lang->groupwrite_nod;
         if ($security == "6") $security = $owl_lang->everyonewrite_nod;
         if ($security == "7") $security = $owl_lang->groupwrite_worldread;
         if ($security == "8") $security = $owl_lang->groupwrite_worldread_nod;

         $choped = split("\.", $sql->f("filename"));
         $pos = count($choped);
         $ext = strtolower($choped[$pos-1]);

         print("<TABLE WIDTH=66% BORDER=$default->table_border><TR><TD ALIGN='RIGHT' BGCOLOR='$default->table_header_bg'>
                               $owl_lang->title:</TD><TD align=left>");
         print $sql->f("name");
         print("&nbsp;&nbsp;");


         // Tiian change 2003-07-31
         $pos = strpos(get_dirpath($sql->f("parent")), "backup");
         if (is_integer($pos) && $pos)
         {
             $is_backup_folder = true;
         }
         else
         {
             $is_backup_folder = false;
         }
         printFileIcons($sql->f("id"), $sql->f("filename"), $sql->f("checked_out"), $sql->f("url"), $default->owl_version_control, $ext, $sql->f("parent"),$is_backup_folder);

         print("</TD></TR><TR><TD ALIGN='RIGHT' BGCOLOR='$default->table_header_bg'>$owl_lang->file:</TD><TD align=left>" . $sql->f("filename") . "&nbsp;(" . gen_filesize($sql->f("size")) . ")</TD></TR>"); 
         // if a MP3 tag was found Display the information
         $filepath = $default->owl_FileDir . "/" . get_dirpath($sql->f("parent")) . "/" . $sql->f("filename");
         if ($sql->f("url") != 1 && file_exists($filepath))
         {
            $id3 = new id3($filepath);

            if ($id3->id3v11 || $id3->id3v1 || $id3->id3v2)
            {
               $id3->study();
               print("<TR><TD ALIGN='RIGHT' VALIGN='TOP' BGCOLOR='$default->table_header_bg'><BR>$owl_lang->disp_mp3<BR><BR></TD>");
               print("<TD align=left>");
               print("<b>$id3->artists - $id3->name <BR>");
               print("$id3->album <BR>");
               print("$id3->bitrate kbps&nbsp;&nbsp;$id3->frequency Hz&nbsp;$id3->mode <BR>");
               print("$id3->length<BR>");
               print("$id3->genre<BR>");
               print("$id3->comment<b>");
               print("</TD></TR>");
            } 
         } 

         print("<TR><TD ALIGN='RIGHT' BGCOLOR='$default->table_header_bg'>$owl_lang->ownership:</TD>
				<TD align=left>" . fid_to_creator($id) . "&nbsp;(" . group_to_name(owlfilegroup($id)) . ")</TD></TR>
				<TR><TD ALIGN='RIGHT' BGCOLOR='$default->table_header_bg'>$owl_lang->permissions:</TD><TD align=left>$security</TD></TR>
				<TR><TD ALIGN='RIGHT' BGCOLOR='$default->table_header_bg'>$owl_lang->keywords:</TD><TD align=left>" . $sql->f("metadata") . "</TD></TR>
                               <TR><TD ALIGN='RIGHT' BGCOLOR='$default->table_header_bg' VALIGN='TOP'>$owl_lang->description:</TD><TD align=left><TEXTAREA NAME=description ROWS=10 readonly  COLS=50>" . $sql->f("description") . "</TEXTAREA></TABLE><BR>");
         include(_SYSCOMMONROOT . "/lib/footer.inc");
      } 
   } 
} 

if ($action == "image_preview")
{
   if (check_auth($id, "file_download", $userid) == 1)
   {
      $path = find_path($parent) . "/" . flid_to_filename($id);
      print("$owl_lang->viewing ");
      $iNewParent = owlfolderparent($parent);
      if ($iNewParent != 0)
      {
         print("<A HREF='browse.php?sess=$sess&parent=$iNewParent&expand=$expand&order=$order&$sortorder=$sort' TITLE='$owl_lang->title_return_folder " . flid_to_name($iNewParent) . "'><img border='0' src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_nav/folder_up.gif' width ='16' height='16'></A>");
      } 
      else
      {
         print("<img border='0' src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_nav/folder_up.gif' width ='16' height='16'>");
      } 
      print(gen_navbar($parent, $id));

      print("<HR WIDTH=50%><BR><BR>");

      $self = $_SERVER["PHP_SELF"];
      print("<IMG SRC='$self?sess=$sess&id=$id&action=image_show&parent=$parent'>");
   } 
   else
   {
      print($owl_lang->err_nofileaccess);
   } 
} 

if ($action == "zip_preview")
{
   if (check_auth($id, "file_download", $userid) == 1)
   {
      $name = flid_to_filename($id);

      if ($default->owl_use_fs)
      {
         $path = find_path($parent) . "/" . $name;
      } 
      else
      {
         $path = $name;
         if (file_exists($default->owl_FileDir . "/$path")) unlink($default->owl_FileDir . "/$path");
         $file = fopen($default->owl_FileDir . "/$path", 'wb');
         $sql->query("select data,compressed from $default->owl_files_data_table where id='$id'");
         while ($sql->next_record())
         {
            if ($sql->f("compressed"))
            {
               $tmpfile = $default->owl_tmpdir . "/owltmp.$id.gz";
               $uncomptmpfile = $default->owl_tmpdir . "/owltmp.$id";
               if (file_exists($tmpfile)) unlink($tmpfile);

               $fp = fopen($tmpfile, "wb");
               fwrite($fp, $sql->f("data"));
               fclose($fp);

               system($default->gzip_path . " -df $tmpfile");

               $fsize = filesize($uncomptmpfile);
               $fd = fopen($uncomptmpfile, 'rb');
               $filedata = fread($fd, $fsize);
               fclose($fd);

               fwrite($file, $filedata);
               unlink($uncomptmpfile);
            } 
            else
            {
               fwrite($file, $sql->f("data"));
            } 
            fclose($file);
         } 
      } 

      print("$owl_lang->viewing ");
      $iNewParent = owlfolderparent($parent);
      if ($iNewParent != 0)
      {
         print("<A HREF='browse.php?sess=$sess&parent=$iNewParent&expand=$expand&order=$order&$sortorder=$sort' TITLE='$owl_lang->title_return_folder " . flid_to_name($iNewParent) . "'><img border='0' src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_nav/folder_up.gif' width ='16' height='16'></A>");
      } 
      else
      {
         print("<img border='0' src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_nav/folder_up.gif' width ='16' height='16'>");
      } 
      print(gen_navbar($parent, $id));

      print("<HR WIDTH=50%><BR><BR>");
      print("<TABLE BORDER=$default->table_border CELLPADDING=0 CELLSPACING=0><TR><TD ALIGN=LEFT><PRE>");

      if ($filext == "tar")
      {
         $expr = "-tvf ";
         $unzipbin = "$default->tar_path $expr " . "\"" . "./" . $path . "\" ";
         if (substr(php_uname(), 0, 7) != "Windows")
         {
            $unzipbin .= " 2>&1";
         } 
         passthru("$unzipbin");
      } 
      else if (($filext == "tar.gz") || ($filext == "tgz"))
      {
         $expr = "-tz ";
         $unzipbin = "$default->tar_path $expr  < " . "\"" . "./" . $path . "\" ";
         if (substr(php_uname(), 0, 7) != "Windows")
         {
            $unzipbin .= " 2>&1";
         } 
         passthru("$unzipbin");
      } elseif ($filext == "gz")
      {
         $expr = "-lt";
         $unzipbin = "$default->gzip_path $expr " . "\"" . "./" . $path . "\" ";
         if (substr(php_uname(), 0, 7) != "Windows")
         {
            $unzipbin .= " 2>&1";
         } 
         passthru("$unzipbin");
      } 
      else if ($filext == "zip")
      {
         $expr = "-l";
         $unzipbin = "$default->unzip_path $expr " . "\"" .  $default->owl_FileDir  . "/" . $path . "\" ";
         if (substr(php_uname(), 0, 7) != "Windows")
         {
            $unzipbin .= " 2>&1";
         } 
         passthru("$unzipbin");
         exit;
      } 
      else
         exit();

      if (!$default->owl_use_fs)
      {
         unlink($default->owl_FileDir . "/$path");
      } 
      print("</PRE></TD></TR></TABLE>");
   } 
   else
   {
      print($owl_lang->err_nofileaccess);
   } 
} 
// BEGIN wes change
if ($action == "html_show" || $action == "text_show" || $action == "note_show" || $action == "pod_show")
{
   if (check_auth($id, "file_download", $userid) == 1)
   {
      if ($default->owl_use_fs)
      {
         $path = $default->owl_FileDir . "/" . find_path($parent) . "/" . flid_to_filename($id);
         print("<BR>$owl_lang->viewing ");
         $iNewParent = owlfolderparent($parent);
         if ($iNewParent != 0)
         {
            print("<A HREF='browse.php?sess=$sess&parent=$iNewParent&expand=$expand&order=$order&$sortorder=$sort' TITLE='$owl_lang->title_return_folder " . flid_to_name($iNewParent) . "'><img border='0' src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_nav/folder_up.gif' width ='16' height='16'></A>");
         } 
         else
         {
            print("<img border='0' src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_nav/folder_up.gif' width ='16' height='16'>");
         } 
         print(gen_navbar($parent, $id));

         print("<HR WIDTH=50%><BR><BR></CENTER>");
         print('<div align="center">');
         print("<table border='0' cellpadding='0' cellspacing='0' width='$default->table_expand_width'>");
         print('<tr>');
         print("<td align='left' bgcolor='$default->main_header_bgcolor'>");
         print('<p align="left">');
         if ($action == "text_show") 
         {
            print("<xmp>"); 
         }
         if ($action == "pod_show")
         {
            if (file_exists($default->pod2html_path))
            {
               $sOwltmpview = $default->owl_tmpdir . "/owltmpview.$id.$sess";
               $mystring = system("$default->pod2html_path --cachedir=$default->owl_tmpdir --infile=$path --outfile=$sOwltmpview");
               readfile("$sOwltmpview"); 
	       myDelete($sOwltmpview); 
            }
            else 
            {
               print("<H2>$owl_lang->err_pod2html_not_found $default->pod2html_path</H2>");
            }
         }
         else
         {
            readfile("$path"); 
         }
         if ($action == "text_show") 
         {
            print("</xmp>");
         }
         print('</td>');
         print('</tr>');
         print('</table>');
         print('</div>');
      } 
      else
      {
         print("$owl_lang->viewing /" . find_path($parent) . "/" . flid_to_filename($id) . "<HR WIDTH=50%><BR><BR></CENTER>");

         print('<div align="center">');
         print("<table border='0' cellpadding='0' cellspacing='0' width='$default->table_expand_width'>");
         print('<tr>');
         print("<td align='left' bgcolor='$default->main_header_bgcolor'>");
         print('<p align="left">');
         if ($action == "text_show") print("<xmp>");

         $sql->query("select data,compressed from " . $default->owl_files_data_table . " where id='$id'");

         while ($sql->next_record())
         {
            if ($sql->f("compressed"))
            {
               $tmpfile = $default->owl_tmpdir . "/owltmp.$id";
               if (file_exists($tmpfile)) unlink($tmpfile);

               $fp = fopen($tmpfile, "wb");
               fwrite($fp, $sql->f("data"));
               fclose($fp);
               flush(passthru($default->gzip_path . " -dfc $tmpfile"));
               unlink($tmpfile);
            } 
            else
            {
               print $sql->f("data");
            } 
         } 
      } 
      if ($action == "text_show") print("</xmp>");
      print('</td>');
      print('</tr>');
      print('</table>');
      print('</div>');
      $path = find_path($parent) . "/" . flid_to_filename($id);
   } 
   else
   {
      print($owl_lang->err_nofileaccess);
   } 
} 
// end wes change

?>
